> For the complete documentation index, see [llms.txt](https://docs.rierino.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rierino.com/devops/api-event-and-process-flows/configuring-saga-steps/event-step/flow-actions/run-multiple-steps.md).

# Run Multiple Steps

## Run Multiple Steps Actions

### RunSteps

Runs multiple steps sequentially and passes each one's result to the next. Event metadata fields applicable for this action are as follows:

{% tabs %}
{% tab title="Table" %}

| Field          | Definition                                                                                | Example    | Default |
| -------------- | ----------------------------------------------------------------------------------------- | ---------- | ------- |
| Domain         | Name of the system to make REST call to (url and auth parameters of this system are used) | erp        | -       |
| Input Element  | Json path for the input in request event payload                                          | parameters | -       |
| Output Element | Json path for the output in response event payload                                        | product    | -       |
| {% endtab %}   |                                                                                           |            |         |

{% tab title="JSON Schema" %}

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "eventMeta": {
      "type": "object",
      "properties": {
        "domain": {
          "type": "string",
          "definition": "Name of the system to make REST call to (url and auth parameters of this system are used)",
          "example": "erp",
          "default": null
        },
        "inputElement": {
          "type": "string",
          "definition": "Json path for the input in request event payload",
          "example": "parameters",
          "default": null
        },
        "outputElement": {
          "type": "string",
          "definition": "Json path for the output in response event payload",
          "example": "product",
          "default": null
        }
      }
    }
  }
}
```

{% endtab %}
{% endtabs %}

With event metadata parameters as:

{% tabs %}
{% tab title="Table" %}

| Parameter     | Definition                                       | Example                   | Default |
| ------------- | ------------------------------------------------ | ------------------------- | ------- |
| Common Fields | Event metadata fields applicable for all steps   | inputElement=parameters   | -       |
| Step Action   | Name of the action to run for step \[step]       | GetQuery                  | -       |
| Step Fields   | Event metadata field applicable for step \[step] | {id:parameters.productid} | -       |
| {% endtab %}  |                                                  |                           |         |

{% tab title="JSON Schema" %}

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "eventMeta": {
      "type": "object",
      "properties": {
        "parameters": {
          "type": "object",
          "properties": {
            "common.[field]": {
              "type": "string",
              "definition": "Event metadata fields applicable for all steps",
              "example": "inputElement=parameters",
              "default": null
            },
            "step_[step]_action": {
              "type": "string",
              "definition": "Name of the action to run for step [step]",
              "example": "GetQuery",
              "default": null
            },
            "step_[step].[field]": {
              "type": "string",
              "definition": "Event metadata field applicable for step [step]",
              "example": "{id:parameters.productid}",
              "default": null
            }
          }
        }
      }
    }
  }
}
```

{% endtab %}
{% endtabs %}

<details>

<summary>Example</summary>

Input

```json
{
    "parameters": {
        "language": "enUS"
    },
    "facets":{
        "brands": ["brand-1"],
        "categories": ["cat-1"]
    }

}
```

Event Metadata

![](/files/seejAgFJICIuMjae8fr3)

</details>

{% hint style="info" %}
Common event metadata fields are used as default and merged with step specific metadata fields such as inputElement, handler or parameters.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.rierino.com/devops/api-event-and-process-flows/configuring-saga-steps/event-step/flow-actions/run-multiple-steps.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
